set ns [new Simulator]

set testTime 25

set rate11  50000
set cir11  50000
set cbs11    2000

set rate21  50000
set cir21  50000
set cbs21    2000

set rate31  50000
set cir31  50000
set cbs31    2000

set rate41  50000
set cir41  50000
set cbs41    2000

set rate51  50000
set cir51  50000
set cbs51    2000



set cir12  350000
set cbs12    20000


set cir22  350000
set cbs22    20000


set cir32  350000
set cbs32    20000


set cir42  350000
set cbs42    20000


set cir52  350000
set cbs52    20000

set TCP_Packet_Size 1000
set UDP_Packet_Size 160

# Open a file for writing the trace data
set trace_all [open out.all w]

# Trace all events for post processing with animator (nam) or with any
# other software
$ns trace-all $trace_all 



# Set up the network topology shown at the top of this file:
set s11 [$ns node]
set s12 [$ns node]
set s21 [$ns node]
set s22 [$ns node]
set s31 [$ns node]
set s32 [$ns node]
set s41 [$ns node]
set s42 [$ns node]
set s51 [$ns node]
set s52 [$ns node]
set e1 [$ns node]
set e2 [$ns node]
set e3 [$ns node]
set e4 [$ns node]
set e5 [$ns node]
set c1 [$ns node]
set c2 [$ns node]
set dest [$ns node]

$ns duplex-link $s11 $e1 10Mb 5ms DropTail
$ns duplex-link $s12 $e1 10Mb 5ms DropTail
$ns duplex-link $s21 $e2 10Mb 5ms DropTail
$ns duplex-link $s22 $e2 10Mb 5ms DropTail
$ns duplex-link $s31 $e3 10Mb 5ms DropTail
$ns duplex-link $s32 $e3 10Mb 5ms DropTail
$ns duplex-link $s41 $e4 10Mb 5ms DropTail
$ns duplex-link $s42 $e4 10Mb 5ms DropTail
$ns duplex-link $s51 $e5 10Mb 5ms DropTail
$ns duplex-link $s52 $e5 10Mb 5ms DropTail


$ns simplex-link $e1 $c1 10Mb 5ms dsRED/edge
$ns simplex-link $e2 $c1 10Mb 5ms dsRED/edge
$ns simplex-link $e3 $c1 10Mb 5ms dsRED/edge
$ns simplex-link $e4 $c1 10Mb 5ms dsRED/edge
$ns simplex-link $e5 $c1 10Mb 5ms dsRED/edge

$ns simplex-link $c1 $e1 10Mb 5ms dsRED/core
$ns simplex-link $c1 $e2 10Mb 5ms dsRED/core
$ns simplex-link $c1 $e3 10Mb 5ms dsRED/core
$ns simplex-link $c1 $e4 10Mb 5ms dsRED/core
$ns simplex-link $c1 $e5 10Mb 5ms dsRED/core

$ns simplex-link $c1 $c2 2Mb 50ms dsRED/core
$ns simplex-link $c2 $c1 2Mb 50ms dsRED/core

$ns simplex-link $c2 $dest 10Mb 5ms dsRED/core
$ns simplex-link $dest $c2 10Mb 5ms dsRED/edge

# Set DS RED parameters from Edge1 to Core1:
set qE1C1 [[$ns link $e1 $c1] queue]
$qE1C1 meanPktSize 1000
$qE1C1 set numQueues_ 1
$qE1C1 setNumPrec 2
$qE1C1 addPolicyEntry [$s11 id] [$dest id] TokenBucket 10 $cir11 $cbs11
$qE1C1 addPolicyEntry [$s12 id] [$dest id] TokenBucket 10 $cir12 $cbs12
$qE1C1 addPolicerEntry TokenBucket 10 11
$qE1C1 addPHBEntry 10 0 0
$qE1C1 addPHBEntry 11 0 1
$qE1C1 configQ 0 0 10 40 0.02
$qE1C1 configQ 0 1 10 40 0.15

# Set DS RED parameters from Core1 to Edge1:
set qC1E1 [[$ns link $c1 $e1] queue]
$qC1E1 meanPktSize 1000
$qC1E1 set numQueues_ 1
$qC1E1 setNumPrec 2
$qC1E1 addPHBEntry 10 0 0
$qC1E1 addPHBEntry 11 0 1
$qC1E1 configQ 0 0 10 40 0.02
$qC1E1 configQ 0 1 10 40 0.15


# Set DS RED parameters from Edge2 to Core1:
set qE2C1 [[$ns link $e2 $c1] queue]
$qE2C1 meanPktSize 1000
$qE2C1 set numQueues_ 1
$qE2C1 setNumPrec 2
$qE2C1 addPolicyEntry [$s21 id] [$dest id] TokenBucket 10 $cir21 $cbs21
$qE2C1 addPolicyEntry [$s22 id] [$dest id] TokenBucket 10 $cir22 $cbs22
$qE2C1 addPolicerEntry TokenBucket 10 11
$qE2C1 addPHBEntry 10 0 0
$qE2C1 addPHBEntry 11 0 1
$qE2C1 configQ 0 0 10 40 0.02
$qE2C1 configQ 0 1 10 40 0.15


# Set DS RED parameters from Core1 to Edge2:
set qC1E2 [[$ns link $c1 $e2] queue]
$qC1E2 meanPktSize 1000
$qC1E2 set numQueues_ 1
$qC1E2 setNumPrec 2
$qC1E2 addPHBEntry 10 0 0
$qC1E2 addPHBEntry 11 0 1
$qC1E2 configQ 0 0 10 40 0.02
$qC1E2 configQ 0 1 10 40 0.15


# Set DS RED parameters from Edge3 to Core1:
set qE3C1 [[$ns link $e3 $c1] queue]
$qE3C1 meanPktSize 1000
$qE3C1 set numQueues_ 1
$qE3C1 setNumPrec 2
$qE3C1 addPolicyEntry [$s31 id] [$dest id] TokenBucket 10 $cir31 $cbs31
$qE3C1 addPolicyEntry [$s32 id] [$dest id] TokenBucket 10 $cir32 $cbs32
$qE3C1 addPolicerEntry TokenBucket 10 11
$qE3C1 addPHBEntry 10 0 0
$qE3C1 addPHBEntry 11 0 1
$qE3C1 configQ 0 0 10 40 0.02
$qE3C1 configQ 0 1 10 40 0.15

# Set DS RED parameters from Core1 to Edge3:
set qC1E3 [[$ns link $c1 $e3] queue]
$qC1E3 meanPktSize 1000
$qC1E3 set numQueues_ 1
$qC1E3 setNumPrec 2
$qC1E3 addPHBEntry 10 0 0
$qC1E3 addPHBEntry 11 0 1
$qC1E3 configQ 0 0 10 40 0.02
$qC1E3 configQ 0 1 10 40 0.15


# Set DS RED parameters from Edge4 to Core1:
set qE4C1 [[$ns link $e4 $c1] queue]
$qE4C1 meanPktSize 1000
$qE4C1 set numQueues_ 1
$qE4C1 setNumPrec 2
$qE4C1 addPolicyEntry [$s41 id] [$dest id] TokenBucket 10 $cir41 $cbs41
$qE4C1 addPolicyEntry [$s42 id] [$dest id] TokenBucket 10 $cir42 $cbs42
$qE4C1 addPolicerEntry TokenBucket 10 11
$qE4C1 addPHBEntry 10 0 0
$qE4C1 addPHBEntry 11 0 1
$qE4C1 configQ 0 0 10 40 0.02
$qE4C1 configQ 0 1 10 40 0.15

# Set DS RED parameters from Core4 to Edge1:
set qC1E4 [[$ns link $c1 $e4] queue]
$qC1E4 meanPktSize 1000
$qC1E4 set numQueues_ 1
$qC1E4 setNumPrec 2
$qC1E4 addPHBEntry 10 0 0
$qC1E4 addPHBEntry 11 0 1
$qC1E4 configQ 0 0 10 40 0.02
$qC1E4 configQ 0 1 10 40 0.15


# Set DS RED parameters from Edge5 to Core:
set qE5C1 [[$ns link $e5 $c1] queue]
$qE5C1 meanPktSize 1000
$qE5C1 set numQueues_ 1
$qE5C1 setNumPrec 2
$qE5C1 addPolicyEntry [$s51 id] [$dest id] TokenBucket 10 $cir51 $cbs51
$qE5C1 addPolicyEntry [$s52 id] [$dest id] TokenBucket 10 $cir52 $cbs52
$qE5C1 addPolicerEntry TokenBucket 10 11
$qE5C1 addPHBEntry 10 0 0
$qE5C1 addPHBEntry 11 0 1
$qE5C1 configQ 0 0 10 40 0.02
$qE5C1 configQ 0 1 10 40 0.15

# Set DS RED parameters from Core1 to Edge5:
set qC1E5 [[$ns link $c1 $e5] queue]
$qC1E5 meanPktSize 1000
$qC1E5 set numQueues_ 1
$qC1E5 setNumPrec 2
$qC1E5 addPHBEntry 10 0 0
$qC1E5 addPHBEntry 11 0 1
$qC1E5 configQ 0 0 10 40 0.02
$qC1E5 configQ 0 1 10 40 0.15


# Set DS RED parameters from Core1 to Core2:
set qC1C2 [[$ns link $c1 $c2] queue]
$qC1C2 meanPktSize 1000
$qC1C2 set numQueues_ 1
$qC1C2 setNumPrec 2
$qC1C2 addPHBEntry 10 0 0
$qC1C2 addPHBEntry 11 0 1
$qC1C2 configQ 0 0 10 40 0.02
$qC1C2 configQ 0 1 10 40 0.15

# Set DS RED parameters from Core2 to Core1:
set qC2C1 [[$ns link $c2 $c1] queue]
$qC2C1 meanPktSize 1000
$qC2C1 set numQueues_ 1
$qC2C1 setNumPrec 2
$qC2C1 addPHBEntry 10 0 0
$qC2C1 addPHBEntry 11 0 1
$qC2C1 configQ 0 0 10 40 0.02
$qC2C1 configQ 0 1 10 40 0.15



# Set DS RED parameters from Dest to Core2:
set qDC2 [[$ns link $dest $c2] queue]
$qDC2 meanPktSize 1000
$qDC2 set numQueues_ 1
$qDC2 setNumPrec 2
$qDC2 addPolicyEntry [$dest id] [$s11 id] TokenBucket 10 $cir11 $cbs11
$qDC2 addPolicyEntry [$dest id] [$s12 id] TokenBucket 10 $cir12 $cbs12
$qDC2 addPolicyEntry [$dest id] [$s21 id] TokenBucket 10 $cir21 $cbs21
$qDC2 addPolicyEntry [$dest id] [$s22 id] TokenBucket 10 $cir22 $cbs22
$qDC2 addPolicyEntry [$dest id] [$s31 id] TokenBucket 10 $cir31 $cbs31
$qDC2 addPolicyEntry [$dest id] [$s32 id] TokenBucket 10 $cir32 $cbs32
$qDC2 addPolicyEntry [$dest id] [$s41 id] TokenBucket 10 $cir41 $cbs41
$qDC2 addPolicyEntry [$dest id] [$s42 id] TokenBucket 10 $cir42 $cbs42
$qDC2 addPolicyEntry [$dest id] [$s51 id] TokenBucket 10 $cir51 $cbs51
$qDC2 addPolicyEntry [$dest id] [$s52 id] TokenBucket 10 $cir52 $cbs52
$qDC2 addPolicerEntry TokenBucket 10 11
$qDC2 addPHBEntry 10 0 0
$qDC2 addPHBEntry 11 0 1
$qDC2 configQ 0 0 10 40 0.02
$qDC2 configQ 0 1 10 40 0.15

# Set DS RED parameters from Core2 to Dest:
set qC2D [[$ns link $c2 $dest] queue]
$qC2D meanPktSize 1000
$qC2D set numQueues_ 1
$qC2D setNumPrec 2
$qC2D addPHBEntry 10 0 0
$qC2D addPHBEntry 11 0 1
$qC2D configQ 0 0 10 40 0.02
$qC2D configQ 0 1 10 40 0.15


# Set up one FTP connection between each source and the destination:
set udp11 [new Agent/UDP]
$ns attach-agent $s11 $udp11
set cbr11 [new Application/Traffic/CBR]
$cbr11 attach-agent $udp11
$cbr11 set packet_size_ $UDP_Packet_Size
$udp11 set packetSize_ $UDP_Packet_Size
$cbr11 set rate_ $rate11
set null11 [new Agent/Null]
$ns attach-agent $dest $null11
$ns connect $udp11 $null11

set udp21 [new Agent/UDP]
$ns attach-agent $s21 $udp21
set cbr21 [new Application/Traffic/CBR]
$cbr21 attach-agent $udp21
$cbr21 set packet_size_ $UDP_Packet_Size
$udp21 set packetSize_ $UDP_Packet_Size
$cbr21 set rate_ $rate21
set null21 [new Agent/Null]
$ns attach-agent $dest $null21
$ns connect $udp21 $null21

set udp31 [new Agent/UDP]
$ns attach-agent $s31 $udp31
set cbr31 [new Application/Traffic/CBR]
$cbr31 attach-agent $udp31
$cbr31 set packet_size_ $UDP_Packet_Size
$udp31 set packetSize_ $UDP_Packet_Size
$cbr31 set rate_ $rate31
set null31 [new Agent/Null]
$ns attach-agent $dest $null31
$ns connect $udp31 $null31

set udp41 [new Agent/UDP]
$ns attach-agent $s41 $udp41
set cbr41 [new Application/Traffic/CBR]
$cbr41 attach-agent $udp41
$cbr41 set packet_size_ $UDP_Packet_Size
$udp41 set packetSize_ $UDP_Packet_Size
$cbr41 set rate_ $rate41
set null41 [new Agent/Null]
$ns attach-agent $dest $null41
$ns connect $udp41 $null41

set udp51 [new Agent/UDP]
$ns attach-agent $s51 $udp51
set cbr51 [new Application/Traffic/CBR]
$cbr51 attach-agent $udp51
$cbr51 set packet_size_ $UDP_Packet_Size
$udp51 set packetSize_ $UDP_Packet_Size
$cbr51 set rate_ $rate51
set null51 [new Agent/Null]
$ns attach-agent $dest $null51
$ns connect $udp51 $null51

set tcp12 [new Agent/TCP]
$ns attach-agent $s12 $tcp12
set ftp12 [new Application/FTP]
$ftp12 attach-agent $tcp12
$tcp12 set packetSize_ $TCP_Packet_Size
set sink12 [new Agent/TCPSink]
$ns attach-agent $dest $sink12
$ns connect $tcp12 $sink12

set tcp22 [new Agent/TCP]
$ns attach-agent $s22 $tcp22
set ftp22 [new Application/FTP]
$ftp22 attach-agent $tcp22
$tcp22 set packetSize_ $TCP_Packet_Size
set sink22 [new Agent/TCPSink]
$ns attach-agent $dest $sink22
$ns connect $tcp22 $sink22


set tcp32 [new Agent/TCP]
$ns attach-agent $s32 $tcp32
set ftp32 [new Application/FTP]
$ftp32 attach-agent $tcp32
$tcp32 set packetSize_ $TCP_Packet_Size
set sink32 [new Agent/TCPSink]
$ns attach-agent $dest $sink32
$ns connect $tcp32 $sink32


set tcp42 [new Agent/TCP]
$ns attach-agent $s42 $tcp42
set ftp42 [new Application/FTP]
$ftp42 attach-agent $tcp42
$tcp42 set packetSize_ $TCP_Packet_Size
set sink42 [new Agent/TCPSink]
$ns attach-agent $dest $sink42
$ns connect $tcp42 $sink42


set tcp52 [new Agent/TCP]
$ns attach-agent $s52 $tcp52
set ftp52 [new Application/FTP]
$ftp52 attach-agent $tcp52
$tcp52 set packetSize_ $TCP_Packet_Size
set sink52 [new Agent/TCPSink]
$ns attach-agent $dest $sink52
$ns connect $tcp52 $sink52



proc finish {} {
    global ns trace_all
    close $trace_all

    #Following are awk scripts to process trace of all events.

    exec awk {
	{
	    if (($1 == "r") && ($4 == "17"))\
		    print $2, $9, $6
	}
    } out.all > out.rec
	

    exit 0
}


$qE1C1 printPolicyTable
$qE1C1 printPolicerTable
$qE1C1 printPHBTable

$ns at 0.0 "$cbr11 start"
$ns at 0.0 "$cbr21 start"
$ns at 0.0 "$cbr31 start"
$ns at 0.0 "$cbr41 start"
$ns at 0.0 "$cbr51 start"
$ns at 0.0 "$ftp12 start"
$ns at 0.0 "$ftp22 start"
$ns at 0.0 "$ftp32 start"
$ns at 0.0 "$ftp42 start"
$ns at 0.0 "$ftp52 start"
$ns at 10.0 "$qE1C1 printStats"
$ns at 20.0 "$qE1C1 printStats"
$ns at $testTime "$cbr11 stop"
$ns at $testTime "$cbr21 stop"
$ns at $testTime "$cbr31 stop"
$ns at $testTime "$cbr41 stop"
$ns at $testTime "$cbr51 stop"
$ns at $testTime "$ftp12 stop"
$ns at $testTime "$ftp22 stop"
$ns at $testTime "$ftp32 stop"
$ns at $testTime "$ftp42 stop"
$ns at $testTime "$ftp52 stop"
$ns at [expr $testTime + 1.0] "finish"

$ns run
